diff --git a/gnu/packages/machine-learning.scm b/gnu/packages/machine-learning.scm
index fff7a8c24a..eb7315730a 100644
--- a/gnu/packages/machine-learning.scm
+++ b/gnu/packages/machine-learning.scm
@@ -1361,8 +1361,7 @@ (define-public onnx
             (lambda* (#:key outputs tests? #:allow-other-keys)
               ;; For derived package use
               (substitute* "CMakeLists.txt"
-                (("set\\(ONNX_ROOT.*")
-                 (string-append "set(ONNX_ROOT "#$(package-source this-package) ")\n"))
+                (("set\\(ONNX_ROOT.*") "")
                 (("\\$\\{ROOT_DIR\\}(/tools.*)" _ rest)
                  (string-append "${PROJECT_SOURCE_DIR}" rest)))
               ;; Pass options to the CMake-based build process.
@@ -1382,14 +1381,15 @@ (define args
                       (string-append "-DONNX_BUILD_TESTS="
                                      (if tests? "ON" "OFF"))
                       "-DBUILD_SHARED_LIBS=ON"
-                      "-DONNX_USE_PROTOBUF_SHARED_LIBS=ON"))
+                      "-DONNX_USE_PROTOBUF_SHARED_LIBS=ON"
+                      (string-append
+                       "-DONNX_ROOT=" #$(package-source this-package))))
 
               ;; This environment variable is honored by 'setup.py',
               ;; which passes it down to 'cmake'.
               (setenv "CMAKE_ARGS" (string-join args))
 
-              ;; This one is honored by 'setup.py' and passed to 'make
-              ;; -j'.
+              ;; This one is honored by 'setup.py' and passed to 'make -j'.
               (setenv "MAX_JOBS"
                       (number->string (parallel-job-count)))))
           (add-before 'check 'make-test-directory-writable
@@ -1445,8 +1445,8 @@ (define-public python-onnx
 (define-public onnx-optimizer
   (package
     (name "onnx-optimizer")
-    ;; Note: 0.2.x is *more* recent than 1.5.0.
-    (version "0.2.6")
+    ;; Note: 0.3.x is *more* recent than 1.5.0.
+    (version "0.3.19")
     (home-page "https://github.com/onnx/optimizer")
     (source (origin
               (method git-fetch)
@@ -1455,7 +1455,7 @@ (define-public onnx-optimizer
                     (commit (string-append "v" version))))
               (sha256
                (base32
-                "1wkqqdxcxpfbf8zpbdfdd3zz5jkw775g31gyykj11z4y6pp659l6"))
+                "1mx3hsl42na6fr05nh2x3j9kxm56cpfmwk6lwl2cfq9zs3gv929w"))
               (file-name (git-file-name name version))
               (patches (search-patches "onnx-optimizer-system-library.patch"))
               (modules '((guix build utils)))
@@ -1466,10 +1466,35 @@ (define-public onnx-optimizer
      (substitute-keyword-arguments (package-arguments onnx)
        ((#:phases phases)
         #~(modify-phases #$phases
-            (delete 'relax-requirements)))))
+            (add-after 'pass-cmake-arguments
+                'pass-onnx-optimizer-cmake-arguments
+              (lambda _
+                (setenv
+                 "CMAKE_ARGS"
+                 (string-append
+                  (getenv "CMAKE_ARGS")
+                  " -DONNX_OPT_USE_SYSTEM_PROTOBUF=ON"
+                  " -DCMAKE_CXX_FLAGS=\"-DONNX_ML=1 -DONNX_NAMESPACE=onnx\""))))
+            (replace 'check
+              (lambda* (#:key tests? #:allow-other-keys)
+                (if tests?
+                    (invoke "pytest" "-vv" "-k"
+                            ;; These tests fail with upstream ONNX:
+                            ;; https://github.com/onnx/optimizer/issues/138
+                            (string-append
+                             "not test_fuse_matmul"
+                             " and not test_fuse_consecutive"
+                             " and not test_fuse_transpose")))))))))
     (native-inputs
-     (list cmake python-pytest python-pytest-runner python-nbval
-           python-coverage))
+     (append
+      (list cmake-minimal python-pytest python-pytest-runner
+            python-coverage)
+      (filter
+       (lambda (pkg)
+         (member (or (%current-target-system)
+                     (%current-system))
+                 (package-transitive-supported-systems pkg)))
+       (list python-nbval))))
     (inputs
      (list onnx protobuf pybind11))
     (propagated-inputs
diff --git a/gnu/packages/patches/onnx-optimizer-system-library.patch b/gnu/packages/patches/onnx-optimizer-system-library.patch
index 5c592597e0..513623fe05 100644
--- a/gnu/packages/patches/onnx-optimizer-system-library.patch
+++ b/gnu/packages/patches/onnx-optimizer-system-library.patch
@@ -1,53 +1,53 @@
-Arrange so that onnx-optimizer (1) uses our own ONNX build, 
-(2) builds as a shared library, and (3) links against the shared
-libraries of ONNX.
+Arrange so that onnx-optimizer uses our own ONNX build, and links against the
+shared libraries of ONNX.
 
 diff --git a/CMakeLists.txt b/CMakeLists.txt
-index c2e48b35..8af51076 100644
+index 00633856..76a73853 100644
 --- a/CMakeLists.txt
 +++ b/CMakeLists.txt
-@@ -9,8 +9,6 @@ endif(NOT MSVC)
+@@ -27,8 +27,6 @@ if(NOT ONNX_OPT_USE_SYSTEM_PROTOBUF)
+ endif()
  
- set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  
 -set(ONNX_ROOT ${PROJECT_SOURCE_DIR}/third_party/onnx)
--add_subdirectory(${ONNX_ROOT})
+-add_subdirectory_if_no_target(${ONNX_ROOT} ${ONNX_TARGET_NAME})
  
  file(READ "${PROJECT_SOURCE_DIR}/VERSION_NUMBER" ONNX_OPTIMIZER_VERSION)
  string(STRIP "${ONNX_OPTIMIZER_VERSION}" ONNX_OPTIMIZER_VERSION)
-@@ -21,14 +19,18 @@ file(GLOB_RECURSE onnx_opt_srcs "onnxoptimizer/*.cc"
+@@ -41,14 +39,14 @@ file(GLOB onnx_opt_srcs "onnxoptimizer/*.cc"
  list(REMOVE_ITEM onnx_opt_srcs "${PROJECT_SOURCE_DIR}/onnxoptimizer/cpp2py_export.cc")
  
- add_library(onnx_optimizer ${onnx_opt_srcs})
--target_link_libraries(onnx_optimizer PUBLIC onnx)
-+target_link_libraries(onnx_optimizer PUBLIC onnx onnx_proto)
+ onnxopt_add_library(onnx_optimizer ${onnx_opt_srcs})
+-target_link_libraries(onnx_optimizer PUBLIC ${ONNX_TARGET_NAME})
++target_link_libraries(onnx_optimizer PUBLIC ${ONNX_TARGET_NAME} onnx_proto)
  target_include_directories(onnx_optimizer PUBLIC
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
      $<INSTALL_INTERFACE:include>
      )
  
-+# These cpp macros must be defined so the ONNX headers behave
-+# correctly.
-+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DONNX_ML=1 -DONNX_NAMESPACE=onnx")
-+
- add_executable(onnx_optimizer_exec examples/onnx_optimizer_exec.cpp)
+ onnxopt_add_executable(onnx_optimizer_exec examples/onnx_optimizer_exec.cpp)
 -target_link_libraries(onnx_optimizer_exec onnx_optimizer)
-+target_link_libraries(onnx_optimizer_exec onnx_optimizer protobuf)
- 
- if(BUILD_ONNX_PYTHON)
-   if("${PY_EXT_SUFFIX}" STREQUAL "")
-@@ -79,11 +81,10 @@ if(BUILD_ONNX_PYTHON)
-                           PRIVATE $<TARGET_OBJECTS:onnx_optimizer>)
-   else()
-     # Assume everything else is like gcc
--    target_link_libraries(onnx_opt_cpp2py_export
--                          PRIVATE "-Wl,--whole-archive" $<TARGET_FILE:onnx_optimizer>
--                                  "-Wl,--no-whole-archive")
-+    target_link_libraries(onnx_opt_cpp2py_export PRIVATE onnx_optimizer)
++target_link_libraries(onnx_optimizer_exec onnx_optimizer onnx_proto)
+ 
+ 
+ file(GLOB onnx_opt_c_api_srcs "onnxoptimizer/c_api/*.cc"
+@@ -116,7 +114,8 @@ if(BUILD_ONNX_PYTHON)
+                           PRIVATE "-Wl,--whole-archive" $<TARGET_FILE:onnx_optimizer>
+                                   "-Wl,--no-whole-archive")
      set_target_properties(onnx_opt_cpp2py_export
 -                          PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,ALL")
-+                          PROPERTIES LINK_FLAGS
-+			  "-Wl,-rpath=${CMAKE_INSTALL_PREFIX}/lib")
++                          PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,ALL,-rpath=${CMAKE_INSTALL_PREFIX}/lib")
++
    endif()
  
    target_link_libraries(onnx_opt_cpp2py_export PRIVATE onnx_optimizer)
+diff --git a/cmake/utils.cmake b/cmake/utils.cmake
+index 6cca9f36..8e39d5c4 100644
+--- a/cmake/utils.cmake
++++ b/cmake/utils.cmake
+@@ -1,4 +1,4 @@
+-include(${PROJECT_SOURCE_DIR}/third_party/onnx/cmake/Utils.cmake)
++include(${ONNX_ROOT}/cmake/Utils.cmake)
+ 
+ # Poor man's FetchContent
+ function(add_subdirectory_if_no_target dir target)