diff --git a/gnu/packages/machine-learning.scm b/gnu/packages/machine-learning.scm
index d7ad9625ce8..1f11ac2a448 100644
--- a/gnu/packages/machine-learning.scm
+++ b/gnu/packages/machine-learning.scm
@@ -985,7 +985,7 @@ (define-public r-rcppml/devel
         (revision "2"))
     (package
       (name "r-rcppml-devel")
-      (version (git-version "0.5.6" revision commit))
+      (version (make-git-version "0.5.6" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -1078,7 +1078,7 @@ (define-public python-hopcroftkarp
         (revision "1"))
     (package
       (name "python-hopcroftkarp")
-      (version (git-version "1.2.5" revision commit))
+      (version (make-git-version "1.2.5" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -1821,7 +1821,7 @@ (define-public gemmlowp
         (revision "1"))
     (package
       (name "gemmlowp")
-      (version (git-version version revision commit))
+      (version (make-git-version version revision commit))
       (home-page "https://github.com/google/gemmlowp")
       (source (origin
                 (method git-fetch)
@@ -2079,7 +2079,7 @@ (define-public python-scikit-learn-extra
         (revision "1"))
     (package
       (name "python-scikit-learn-extra")
-      (version (git-version "0.3.0" revision commit))
+      (version (make-git-version "0.3.0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -2566,7 +2566,7 @@ (define-public python-torchdiffeq
         (revision "0"))
     (package
       (name "python-torchdiffeq")
-      (version (git-version "0.2.5" revision commit))
+      (version (make-git-version "0.2.5" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -2797,7 +2797,7 @@ (define-public kaldi
         (revision "2"))
     (package
       (name "kaldi")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -2915,7 +2915,7 @@ (define kaldi-for-vosk
     (package
       (inherit kaldi)
       (name "kaldi")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -3013,7 +3013,7 @@ (define-public gst-kaldi-nnet2-online
         (revision "3"))
     (package
       (name "gst-kaldi-nnet2-online")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -3084,7 +3084,7 @@ (define-public kaldi-gstreamer-server
         (revision "3"))
     (package
       (name "kaldi-gstreamer-server")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -3959,7 +3959,7 @@ (define-public dmlc-core-next
     (package
       (inherit dmlc-core)
       (name "dmlc-core")
-      (version (git-version "0.5" revision commit))
+      (version (make-git-version "0.5" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -4294,7 +4294,7 @@ (define-public gloo
         (revision "2"))
     (package
       (name "gloo")
-      (version (git-version version revision commit))
+      (version (make-git-version version revision commit))
       (source
        (origin
          (method git-fetch)
@@ -4425,7 +4425,7 @@ (define-public nnpack
         (revision "2"))
     (package
       (name "nnpack")
-      (version (git-version version revision commit))
+      (version (make-git-version version revision commit))
       (home-page "https://github.com/Maratyszcza/NNPACK")
       (source (origin
                 (method git-fetch)
@@ -4469,7 +4469,7 @@ (define-public qnnpack
         (revision "0"))
     (package
       (name "qnnpack")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -4522,7 +4522,7 @@ (define-public xnnpack
         (revision "4"))
     (package
       (name "xnnpack")
-      (version (git-version version revision commit))
+      (version (make-git-version version revision commit))
       (home-page "https://github.com/google/XNNPACK") ;fork of QNNPACK
       (source
        (origin
@@ -4674,7 +4674,7 @@ (define-public xnnpack-for-r-torch
         (revision "2"))
     (package
       (inherit xnnpack)
-      (version (git-version version revision commit))
+      (version (make-git-version version revision commit))
       (source
        (origin
          (method git-fetch)
@@ -4773,7 +4773,7 @@ (define-public tensorpipe
         (revision "0"))
     (package
       (name "tensorpipe")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -4809,7 +4809,7 @@ (define-public tvm
         (revision "1"))
     (package
       (name "tvm")
-      (version (git-version "0.20.dev0" revision commit))
+      (version (make-git-version "0.20.dev0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -4898,7 +4898,7 @@ (define-public foxi
        (revision "0"))
     (package
       (name "foxi")
-      (version (git-version "1.4.1" revision commit))
+      (version (make-git-version "1.4.1" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -5468,7 +5468,7 @@ (define-public python-pytorch-geometric
         (revision "0"))
     (package
       (name "python-pytorch-geometric")
-      (version (git-version "2.6.1" revision commit))
+      (version (make-git-version "2.6.1" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -5718,7 +5718,7 @@ (define-public python-pytorch-lightning
         (revision "0"))
     (package
       (name "python-pytorch-lightning")
-      (version (git-version "2.5.2" revision commit))
+      (version (make-git-version "2.5.2" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -6828,7 +6828,7 @@ (define-public nerd-dictation
          (revision "1"))
     (package
       (name "nerd-dictation")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source
        (origin
          (method git-fetch)
diff --git a/gnu/packages/mail.scm b/gnu/packages/mail.scm
index 08c551d86a2..aa434b8b2a8 100644
--- a/gnu/packages/mail.scm
+++ b/gnu/packages/mail.scm
@@ -464,7 +464,7 @@ (define-public mairix
         (revision "0"))
     (package
       (name "mairix")
-      (version (git-version "0.24" revision commit))
+      (version (make-git-version "0.24" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -1115,7 +1115,7 @@ (define-public ripmime
         (revision "1"))
     (package
       (name "ripmime")
-      (version (git-version "1.4.0.10" revision commit))
+      (version (make-git-version "1.4.0.10" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -1232,7 +1232,7 @@ (define-public offlineimap3
         (revision "0"))
     (package
       (name "offlineimap3")
-      (version (git-version "8.0.0" revision commit))
+      (version (make-git-version "8.0.0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -1287,7 +1287,7 @@ (define-public emacs-mew
         (revision "1"))
     (package
       (name "emacs-mew")
-      (version (git-version "6.9" revision commit))
+      (version (make-git-version "6.9" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -1480,7 +1480,7 @@ (define-public notifymuch
         (revision "1"))
     (package
       (name "notifymuch")
-      (version (git-version "0.1" revision commit))
+      (version (make-git-version "0.1" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -4457,7 +4457,7 @@ (define-public l2md
         (revision "2"))
     (package
       (name "l2md")
-      (version (git-version "0.1.0" revision commit))
+      (version (make-git-version "0.1.0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -5134,7 +5134,7 @@ (define-public sendgmail
         (revision "1"))
     (package
       (name "sendgmail")
-      (version (git-version "0.0.0" revision commit))
+      (version (make-git-version "0.0.0" revision commit))
       (source
        (origin
          (method git-fetch)
diff --git a/gnu/packages/maths.scm b/gnu/packages/maths.scm
index 5be65120279..50ee2108f9b 100644
--- a/gnu/packages/maths.scm
+++ b/gnu/packages/maths.scm
@@ -519,7 +519,7 @@ (define-public dozenal
         (commit "328bc03ad544179f2cccda36763358c4216f188e"))
     (package
       (name "dozenal")
-      (version (git-version "12010904-3" revision commit))
+      (version (make-git-version "12010904-3" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -2994,7 +2994,7 @@ (define-public python-cylp
 
 (define-public gecode
   (let* ((commit "f7f0d7c273d6844698f01cec8229ebe0b66a016a")
-         (version (git-version "6.2.0" "1" commit)))
+         (version (vc-version "6.2.0" "1" commit)))
     (package
       (name "gecode")
       (version version)
@@ -3072,7 +3072,7 @@ (define-public libfixmath
         (revision "1"))
     (package
       (name "libfixmath")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -3170,7 +3170,7 @@ (define-public libflame
         (revision "0"))
     (package
       (name "libflame")
-      (version (git-version "5.2.0" revision commit))
+      (version (make-git-version "5.2.0" revision commit))
       (outputs '("out" "static"))
       (home-page "https://github.com/flame/libflame")
       (source (origin
@@ -5484,7 +5484,7 @@ (define-public gklib
         (revision "1"))
     (package
       (name "gklib")
-      (version (git-version "5.1.1" revision commit))
+      (version (make-git-version "5.1.1" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -8378,7 +8378,7 @@ (define-public symfpu
         (revision "0"))
     (package
       (name "symfpu")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -8412,7 +8412,7 @@ (define-public symfpu
                       Description: library for IEEE-754 floats~@
                       Cflags: -I${includedir}~%"
                      (assoc-ref outputs "out")
-                     #$version))))))))
+                     #$(package-version this-package)))))))))
       (synopsis
        "Concrete and symbolic implementation of IEEE-754 floating-point numbers")
       (description
@@ -8683,7 +8683,7 @@ (define-public elemental
         (revision "0"))
     (package
       (name "elemental")
-      (version (git-version "0.87.7" revision commit))
+      (version (make-git-version "0.87.7" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -8795,7 +8795,7 @@ (define-public tiny-bignum
   (let ((commit "1d7a1f9b8e77316187a6b3eae8e68d60a6f9a4d4"))
     (package
      (name "tiny-bignum")
-     (version (git-version "0" "0" commit))
+     (version (make-git-version "0" "0" commit))
      (source
       (origin
         (method git-fetch)
@@ -9378,7 +9378,7 @@ (define-public dune-subgrid
   (let ((commit "e71cc9c2514356c7cd989f0c13661f10c37c58df"))
     (package
       (name "dune-subgrid")
-      (version (git-version "2.10.0" "1" commit))
+      (version (make-git-version "2.10.0" "1" commit))
       (source
        (origin
          (method git-fetch)
@@ -9515,7 +9515,7 @@ (define-public dune-pdelab
   (let ((commit "d5dddb6b1c21b95e867ff53cca159ad676689f5c"))
     (package
       (name "dune-pdelab")
-      (version (git-version "2.8.0" "0" commit))
+      (version (make-git-version "2.8.0" "0" commit))
       (source
        (origin
          (method git-fetch)
@@ -9891,7 +9891,7 @@ (define-public btor2tools
         (revision "2"))
    (package
    (name "btor2tools")
-   (version (git-version "1.0.0-pre" revision commit))
+   (version (make-git-version "1.0.0-pre" revision commit))
    (source (origin
             (method git-fetch)
             (uri (git-reference
@@ -9973,7 +9973,7 @@ (define-public libtaylor
         (revision "0"))
     (package
       (name "libtaylor")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -10137,7 +10137,7 @@ (define-public cadiback
     (package
       (name "cadiback")
       ;; Note: version taken from VERSION file
-      (version (git-version "0.2.1" revision commit))
+      (version (make-git-version "0.2.1" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -10195,7 +10195,7 @@ (define cadiback-for-cryptominisat
     (package
       (inherit cadiback)
       (name "cadiback-for-cryptominisat")
-      (version (git-version "0.2.1" revision commit))
+      (version (make-git-version "0.2.1" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -10223,7 +10223,7 @@ (define-public louvain-community
         (revision "2"))
     (package
       (name "louvain-community")
-      (version (git-version "1.0.0" revision commit))
+      (version (make-git-version "1.0.0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -10620,7 +10620,7 @@ (define-public fxdiv
         (revision "1"))
     (package
       (name "fxdiv")
-      (version (git-version version revision commit))
+      (version (make-git-version version revision commit))
       (home-page "https://github.com/Maratyszcza/FXdiv")
       (source (origin
                 (method git-fetch)
@@ -10649,7 +10649,7 @@ (define-public fp16
         (revision "1"))
     (package
       (name "fp16")
-      (version (git-version version revision commit))
+      (version (make-git-version version revision commit))
       (home-page "https://github.com/Maratyszcza/FP16")
       (source (origin
                 (method git-fetch)
@@ -10698,7 +10698,7 @@ (define-public optizelle
   (let ((commit "ed4160b5287518448caeb34789d92dc6a0b7e2cc"))
    (package
     (name "optizelle")
-    (version (git-version "1.3.0" "0" commit))
+    (version (make-git-version "1.3.0" "0" commit))
     (source
      (origin
        (method git-fetch)
@@ -11048,7 +11048,7 @@ (define-public ruy
         (revision "1"))
     (package
       (name "ruy")
-      (version (git-version version revision commit))
+      (version (make-git-version version revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
diff --git a/gnu/packages/matrix.scm b/gnu/packages/matrix.scm
index c8edaf5d5aa..0db44a1c6ea 100644
--- a/gnu/packages/matrix.scm
+++ b/gnu/packages/matrix.scm
@@ -314,7 +314,7 @@ (define-public pantalaimon
         (revision "0"))
     (package
       (name "pantalaimon")
-      (version (git-version "0.10.5" revision commit))
+      (version (make-git-version "0.10.5" revision commit))
       (source
        (origin
          (method git-fetch)
diff --git a/gnu/packages/messaging.scm b/gnu/packages/messaging.scm
index 0ac125442f1..f46726545ad 100644
--- a/gnu/packages/messaging.scm
+++ b/gnu/packages/messaging.scm
@@ -769,7 +769,7 @@ (define-public bitlbee-discord
         (revision "1"))
     (package
       (name "bitlbee-discord")
-      (version (git-version "0.4.3" revision commit))
+      (version (make-git-version "0.4.3" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -813,7 +813,7 @@ (define-public purple-mattermost
         (revision "0"))
     (package
       (name "purple-mattermost")
-      (version (git-version "1.2" revision commit))
+      (version (make-git-version "1.2" revision commit))
       (home-page "https://github.com/EionRobb/purple-mattermost")
       (source (origin
                 (method git-fetch)
@@ -841,7 +841,8 @@ (define-public purple-mattermost
                                             "/share/pixmaps/pidgin/protocols\n")))
                           #t))))
          #:make-flags (list "CC=gcc"
-                            ,(string-append "PLUGIN_VERSION=" version))
+                            ,(string-append "PLUGIN_VERSION="
+                                            (package-version this-package)))
          #:tests? #f))
       (inputs (list glib json-glib discount pidgin))
       (native-inputs (list pkg-config))
@@ -2721,7 +2722,7 @@ (define-public tdlib
         (revision "0"))
     (package
       (name "tdlib")
-      (version (git-version "1.8.45" revision commit))
+      (version (make-git-version "1.8.45" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -3017,7 +3018,7 @@ (define-public movim-desktop
     (package
       (name "movim-desktop")
       (version
-       (git-version "0.14.0" revision commit))
+       (make-git-version "0.14.0" revision commit))
       (source
        (origin
          (method git-fetch)
diff --git a/gnu/packages/monitoring.scm b/gnu/packages/monitoring.scm
index 66b1a761d9c..1494f7d33b4 100644
--- a/gnu/packages/monitoring.scm
+++ b/gnu/packages/monitoring.scm
@@ -472,7 +472,7 @@ (define-public graphite-web
         (revision "2"))
     (package
       (name "graphite-web")
-      (version (git-version "1.1.10" revision commit))
+      (version (make-git-version "1.1.10" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -695,7 +695,7 @@ (define-public temper-exporter
         (revision "0"))
     (package
       (name "temper-exporter")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
diff --git a/gnu/packages/mp3.scm b/gnu/packages/mp3.scm
index d2b97372d10..696db65476b 100644
--- a/gnu/packages/mp3.scm
+++ b/gnu/packages/mp3.scm
@@ -287,7 +287,7 @@ (define-public minimp3
         (revision "0"))
     (package
       (name "minimp3")
-      (version (git-version "0.0.0" revision commit))
+      (version (make-git-version "0.0.0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
diff --git a/gnu/packages/multiprecision.scm b/gnu/packages/multiprecision.scm
index bafbc8b6c7c..fceb15d7fe5 100644
--- a/gnu/packages/multiprecision.scm
+++ b/gnu/packages/multiprecision.scm
@@ -166,7 +166,7 @@ (define-public mpfi
         (revision "1"))
     (package
       (name "mpfi")
-      (version (git-version "1.5.4" revision commit))
+      (version (make-git-version "1.5.4" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
diff --git a/gnu/packages/music.scm b/gnu/packages/music.scm
index 680f8d488e8..56caaae3732 100644
--- a/gnu/packages/music.scm
+++ b/gnu/packages/music.scm
@@ -605,7 +605,7 @@ (define-public ctrlr
         (revision "1"))
     (package
       (name "ctrlr")
-      (version (git-version "5.5.9" revision commit))
+      (version (make-git-version "5.5.9" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -1260,7 +1260,7 @@ (define-public extempore
                    (url "https://github.com/extemporelang/extempore-assets")
                    (commit commit)))
              (file-name (git-file-name "extempore-assets"
-                                       (git-version version revision commit)))
+                                       (make-git-version version revision commit)))
              (sha256
               (base32 "1pxmcbngd9qx8m71d5rfsmf4h31jnsnd3wjh8vb0rwskif22xz8l")))))
        ("libffi" ,libffi)
@@ -1275,7 +1275,7 @@ (define-public extempore
            (package
              (inherit stb-image)
              (name "stb-image-for-extempore")
-             (version (git-version "0" revision commit))
+             (version (make-git-version "0" revision commit))
              (source
               (origin (method git-fetch)
                       (uri (git-reference
@@ -1297,7 +1297,7 @@ (define-public extempore
            (package
              (inherit portmidi)
              (name "portmidi-for-extempore")
-             (version (git-version version revision commit))
+             (version (make-git-version version revision commit))
              (source (origin
                        (method git-fetch)
                        (uri (git-reference
@@ -1897,7 +1897,7 @@ (define-public non-sequencer
         (revision "5"))
     (package
       (name "non-sequencer")
-      (version (git-version "1.9.5" revision commit))
+      (version (make-git-version "1.9.5" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -2033,7 +2033,7 @@ (define-public tascam-gtk
         (revision "0"))
     (package
       (name "tascam-gtk")
-      (version (git-version "0.4" revision commit))
+      (version (make-git-version "0.4" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -3251,7 +3251,7 @@ (define-public python-pyportmidi
         (revision "0"))
     (package
       (name "python-pyportmidi")
-      (version (git-version "0.0.7" revision commit))
+      (version (make-git-version "0.0.7" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -3282,7 +3282,7 @@ (define-public python-pysmf
         (revision "1"))
     (package
       (name "python-pysmf")
-      (version (git-version "0.1.1" revision commit))
+      (version (make-git-version "0.1.1" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -3892,7 +3892,7 @@ (define-public mod-host
         (revision "4"))
     (package
       (name "mod-host")
-      (version (git-version "0.10.6" revision commit))
+      (version (make-git-version "0.10.6" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -4003,7 +4003,7 @@ (define-public curseradio
         (revision "1"))
     (package
       (name "curseradio")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -4254,7 +4254,7 @@ (define-public instantmusic
         (revision "1"))
     (package
       (name "instantmusic")
-      (version (git-version "1.0" revision commit))
+      (version (make-git-version "1.0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -4642,7 +4642,7 @@ (define-public mididings
         (revision "2"))
     (package
       (name "mididings")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -4749,7 +4749,7 @@ (define-public gx-vbass-preamp-lv2
         (revision "3"))
     (package (inherit gx-guvnor-lv2)
       (name "gx-vbass-preamp-lv2")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -4867,7 +4867,7 @@ (define-public gx-saturator-lv2
         (revision "4"))
     (package (inherit gx-vbass-preamp-lv2)
       (name "gx-saturator-lv2")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -5004,7 +5004,7 @@ (define-public rkrlv2
         (revision "2"))
     (package
       (name "rkrlv2")
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -5885,7 +5885,7 @@ (define-public luppp
         (commit "23da1497f80dbace48b7807afd3570c57a4d5994"))
     (package
       (name "luppp")
-      (version (git-version "1.2.1" revision commit))
+      (version (make-git-version "1.2.1" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -5944,7 +5944,7 @@ (define-public sorcer
         (commit "94107b26e3e00e32504c8fb3fbf7572514d3b6bc"))
     (package
       (name "sorcer")
-      (version (git-version "1.1.3" revision commit))
+      (version (make-git-version "1.1.3" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -6278,7 +6278,7 @@ (define-public demlo
         (revision "1"))
     (package
       (name "demlo")
-      (version (git-version "3.8" revision commit))
+      (version (make-git-version "3.8" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -6363,7 +6363,7 @@ (define-public go-github-com-wtolson-go-taglib
         (revision "0"))
     (package
       (name "go-github-com-wtolson-go-taglib")
-      (version (git-version "0.0.0" revision commit))
+      (version (make-git-version "0.0.0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -6405,7 +6405,7 @@ (define-public go-github-com-aarzilli-golua
         (revision "0"))
     (package
       (name "go-github-com-aarzilli-golua")
-      (version (git-version "0.0.0" revision commit))
+      (version (make-git-version "0.0.0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -6453,7 +6453,7 @@ (define-public go-github-com-stevedonovan-luar
         (revision "0"))
     (package
       (name "go-github-com-stevedonovan-luar")
-      (version (git-version "0.0.0" revision commit))
+      (version (make-git-version "0.0.0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -6496,7 +6496,7 @@ (define-public go-gitlab-com-ambrevar-golua-unicode
         (revision "0"))
     (package
       (name "go-gitlab-com-ambrevar-golua-unicode")
-      (version (git-version "0.0.0" revision commit))
+      (version (make-git-version "0.0.0" revision commit))
       (source
        (origin
          (method git-fetch)
@@ -7093,7 +7093,7 @@ (define-public distrho-ports
         (revision "0"))
     (package
       (name "distrho-ports")
-      (version (git-version "2021-03-15" revision commit))
+      (version (make-git-version "2021-03-15" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -7737,7 +7737,7 @@ (define-public tap-lv2
         (revision "1"))
     (package
       (name "tap-lv2")
-      (version (git-version "0.0" revision commit))
+      (version (make-git-version "0.0" revision commit))
       (source
         (origin
           (method git-fetch)
@@ -7859,7 +7859,7 @@ (define-public shiru-lv2
         (revision "1"))
     (package
       (name "shiru-lv2")
-      (version (git-version "0.0" revision commit))
+      (version (make-git-version "0.0" revision commit))
       (source
         (origin
           (method git-fetch)
@@ -8155,7 +8155,7 @@ (define-public orca-music
     (package
       (name "orca-music")
       ;; No upstream version numbers; Using commit instead.
-      (version (git-version "0" revision commit))
+      (version (make-git-version "0" revision commit))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference